.TH MFT 1 "16 June 2015" "Web2C @VERSION@"
.\"=====================================================================
.if n .ds MP MetaPost
.if t .ds MP MetaPost
.if n .ds MF Metafont
.if t .ds MF Metafont
.if t .ds TX \fRT\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X\fP
.if n .ds TX TeX
.ie t .ds OX \fIT\v'+0.25m'E\v'-0.25m'X\fP
.el .ds OX TeX
.\" BX definition must follow TX so BX can use TX
.if t .ds BX \fRB\s-2IB\s0\fP\*(TX
.if n .ds BX BibTeX
.\" LX definition must follow TX so LX can use TX
.if t .ds LX \fRL\\h'-0.36m'\\v'-0.15v'\s-2A\s0\\h'-0.15m'\\v'0.15v'\fP\*(TX
.if n .ds LX LaTeX
.\"=====================================================================
.SH NAME
mft \- translate Metafont or MetaPost code to TeX code for prettyprinting
.SH SYNOPSIS
.B mft
.RI [ OPTIONS ]
.BR \fImf_file_name\fP [ .mf | .mp ]
.\"=====================================================================
.SH DESCRIPTION
This manual page is not meant to be exhaustive.  The complete
documentation for this version of \*(TX can be found in the info file
or manual
.IR "Web2C: A TeX implementation" .
.PP
The
.B mft
program creates a \*(TX file from a \*(MF or \*(MP program.
It takes appropriate care of typographic details like page
layout and the use of indentation, italics, boldface, etc., as illustrated
in the book
.IR "Computer Modern Typefaces" .
Special conventions in \*(MF and \*(MP comments allow you to control things that
would not otherwise come out right; section 1 of the MFT source program
in the
.I \*(MFware
report explains these rules.
.PP
The
.B mft
program uses an optional change file (which works just as the change files to
.BR tangle (1)
and
.BR weave (1)
do)
and one or several style files (which are prepended to everything).
If no style file is specified, the style file
.B plain.mft
for \*(MF (or
.B mplain.mft
for \*(MP) is automatically used.
.PP
The
.IR mf_file_name ,
optional
.IR change_file_name ,
and
.I style_file_name
files are searched for using the MFINPUTS (for \*(MF) or MPINPUTS (for
\*(MP) and MFTINPUTS environment variables if you have set them, or else the
corresponding system defaults.
.PP
The output \*(TX file name is formed by using
.B .tex
in place of the extension of
.IR mf_file_name .
.\"=====================================================================
.SH OPTIONS
.TP
.BI \-change= change_file_name \fR[\fP.ch\fR]\fP
Apply the change file
.I change_file_name
to
.IR mf_file_name .
.PP
.TP
.B \-metapost
Assume
.I mf_file_name
is a \*(MP source file (this is the default if
.I mf_file_name
has the extension
.BR .mp ).
.PP
.TP
.BI \-style= style_file_name \fR[\fP.mft\fR]\fP
Use the style file
.I style_file_name
insted of
.B plain.mft
(or
.BR mplain.mft );
this option can be given more than once.
.\"=====================================================================
.SH FILES
.TP
.I mftmac.tex
\*(TX macros used by
.B mft
output.
.TP
.IR plain.mft ", " mplain.mft
Default style files.
.TP
.I cmbase.mft
Style file for Computer Modern.
.\"=====================================================================
.SH "SEE ALSO"
.BR mf (1),
.BR weave (1).
.br
Donald E. Knuth,
.I Computer Modern Typefaces
(Volume E of
.IR "Computers and Typesetting" ),
Addison-Wesley, 1986, ISBN 0-201-13446-2.
.br
Donald E. Knuth et al.,
.IR \*(MFware .
.\"=====================================================================
.SH AUTHORS
Donald E. Knuth wrote the program, and he ported it to Unix with the help of
Pierre MacKay and the Unix port of
.B weave
by Howard Trickey and Pavel Curtis.
The program is published in the
.I \*(MFware
technical report, available from the \*(TX Users Group.
